/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Webserver
 * Bemerkung:         Hauptprogramm des Projektes Webserver
 * Letzte Änderung:   01.11.21
*/

// Projektinspiration
/*
 * Hello world web server
 * circuits4you.com
 * https://circuits4you.com/2016/12/16/esp8266-web-server-html/
 */
 
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include "index.h"                                               

// Eingabe der Zugangsdaten zum W-LAN-Router
const char* ssid = "FRITZ!Box 7490";                              // In der Variable 'ssid' wird der Name des Netzwerks gespeichert (Beispiel: FRITZ!box 7490)
const char* password = "91759863486739187283";                              // In der Variable 'password' wird das Passwort bzw. der Netzwerkschlüssel gespeichert

int led_weiß = 16;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER NICHTS ÄNDERN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ESP8266WebServer server(80);          // Der Server im Port 80 wird mit dem Objekt 'server' gestartet  
          
                                                        ///////////////////////////////////////////////////////////////////////////////////////////////////////
void uebersetzeWebseite() {                             // Diese Funktion wird ausgeführt wenn die IP im Browser aufgerufen wird (z.B. mit einem Smartphone) //
                                                        ///////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                
 String s = hauptseite;               // Speichert den HTML-Code in der Variable 's'
 server.send(200, "text/html", s);    // Der HTML-Code wird an den Webserver gesendet
 
}

void ledAn() { 
 Serial.println("LED An!");
 digitalWrite(led_weiß,HIGH); 
 server.send(200, "text/html", "AN"); //Send ADC value only to client ajax request
}

void ledAus() { 
 Serial.println("LED Aus!");
 digitalWrite(led_weiß,LOW); 
 server.send(200, "text/html", "AUS");
}

void hw_wdt_disable(){
  *((volatile uint32_t*) 0x60000900) &= ~(1); // ESP8266 Watchdog abschalten
}

void hw_wdt_enable(){
  *((volatile uint32_t*) 0x60000900) |= 1; // ESP8266 Watchdog einschalten
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER KÖNNEN EINZELNE PROGRAMMZEILEN VERÄNDERT WERDEN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setup(){

  //hw_wdt_disable();
  //hw_wdt_enable();

  // Serielle Ausgabe bei der Verbindung mit einemk Router  
  Serial.begin(115200);
  
  WiFi.begin(ssid, password);                            // Verbindet einen W-LAN Router durch die obigen Zugansdaten
  Serial.println(" ");                                   // Bei Verbindung mit dem Router zeichen ausgeben (kann verändert werden)              

  while (WiFi.status() != WL_CONNECTED) {                // Auf die Verbindung warten
    
    delay(500);                                          // Alle 500 millisekunden etwas ausgeben (kann verändert werden)
    Serial.print(".");                                   // Beim warten zeichen ausgeben (kann verändert werden)
    
  }

  Serial.println(" ");                                   // Wenn die Verbindung mit dem Router erfolgreich war, folgt eine Meldung (kann verändert werden)
  Serial.print("Verbunden mit dem Router: ");             
  Serial.println(ssid);
  Serial.print("Die IP-Addresse der Webseite lautet: "); // Ausgabe der IP-Adresse, mit der sich über einen Browser auf den Webserver zugreifen lässt (kann verändert werden)
  Serial.println(WiFi.localIP());            
 
  server.on("/", uebersetzeWebseite);                    // Wenn der Webserver online ist, wird dem Objekt 'server' die Funktion 'uebersetzeWebseite' übergeben
  server.on("/ledan", ledAn);                      //as Per  <a href="ledOn">, Subroutine to be called
  server.on("/ledaus", ledAus);
  server.begin();                                        // Initialisiert den Webserver
  Serial.println("Webseite wurde generiert");            // Sobald der Server online ist, wird ein Text ausgegeben (kann verändert werden)

  pinMode(led_weiß, OUTPUT);
  //digitalWrite(led_weiß, LOW);
  
}

void loop(){
  
  server.handleClient();                                 // Serveranfragen werden verarbeitet
  
  
}
